Добро пожаловать!

Войдите или зарегистрируйтесь сейчас!

Войти

Привязка "Геометрический центр"

Тема в разделе "Autodesk", создана пользователем Ellesar, 30 авг 2018.

  1. Ellesar

    Форумчанин

    Регистрация:
    29 авг 2010
    Сообщения:
    110
    Симпатии:
    13
    Добрый день, уважаемые форумчане. В наличии Цивил 2019. Проблема с привязкой "Геометрический центр", а именно с его определением у простейших фигур при переносе или копировании. Как видно на приложенном скриншоте, автокад не верно определяет этот самый геометрический центр. Увеличение или уменьшение кол-ва сегментов переменной PLINEGCENMAX не помогло никак.

    Как вылечить данную болячку? привязка.jpg
     
    #1
  2. Ellesar

    Форумчанин

    Регистрация:
    29 авг 2010
    Сообщения:
    110
    Симпатии:
    13
    Еще один пример. Другой чертеж. привязка1.jpg
     
    #2
  3. landmaling

    Форумчанин

    Регистрация:
    18 май 2015
    Сообщения:
    29
    Симпатии:
    15
    https://forums.autodesk.com/t5/autocad-lt-forum/geometric-center-problem/td-p/6530493

    Ещё можно через Lisp

    ;Center of closed polygon
    ;^P(or C:pc1 (load "pc1.lsp"))(pc1)
    ; (load "pc1.lsp")(pc1)
    (defun pc1 ( / acdoc acspc acsel reg pt) (vl-load-com) ;; © Lee Mac 2011

    (setq acdoc (vla-get-ActiveDocument (vlax-get-acad-object))
    acspc (vlax-get-property acdoc (if (= 1 (getvar 'CVPORT)) 'Paperspace 'Modelspace))
    )
    ; (if (ssget "+.:E:S")
    (if (ssget "+.:E:S" '((0 . "LWPOLYLINE") (-4 . "&=") (70 . 1)))
    (progn
    (vlax-for obj (setq acsel (vla-get-ActiveSelectionSet acdoc))
    (setq pt(trans (vlax-get (setq reg (car (vlax-invoke acspc 'addregion (list obj)))) 'Centroid) 1 0))
    (vla-delete reg)
    )
    (vla-delete acsel)
    )
    )
    pt
    )

    Macro: ^P(or C:pc1 (load "pc1.lsp"))(pc1)
     
    #3

Поделиться этой страницей

  1. Этот сайт использует файлы cookie. Продолжая пользоваться данным сайтом, Вы соглашаетесь на использование нами Ваших файлов cookie.
    Скрыть объявление